diff --git a/jerry-core/parser/js/js-parser.c b/jerry-core/parser/js/js-parser.c
index 472fe63e33..6c23e41548 100644
--- a/jerry-core/parser/js/js-parser.c
+++ b/jerry-core/parser/js/js-parser.c
@@ -2532,7 +2532,14 @@ parser_parse_class_fields (parser_context_t *context_p) /**< context */
 
     if (class_field_type & PARSER_CLASS_FIELD_NORMAL)
     {
+      /* Prepare stack slot for incoming assingment property reference base */
       parser_emit_cbc_literal (context_p, CBC_ASSIGN_PROP_THIS_LITERAL, literal_index);
+      JERRY_ASSERT (context_p->stack_depth == 1);
+
+      if (context_p->stack_limit == 1)
+      {
+        context_p->stack_limit++;
+      }
     }
     else
     {
diff --git a/tests/jerry/es.next/regression-test-issue-4413.js b/tests/jerry/es.next/regression-test-issue-4413.js
new file mode 100644
index 0000000000..3676681da3
--- /dev/null
+++ b/tests/jerry/es.next/regression-test-issue-4413.js
@@ -0,0 +1,16 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+assert((new (class C2 { x = 5 })).x === 5);
+assert((new (class C2 { x = {} + {} })).x === "[object Object][object Object]");
